# 访客需求整理
## 人行
### v1实现
在v1中，访客分为访客预约跟邀请访客两种模式。其中访客预约是访客主动预约访问某个项目通道。邀请访客则是项目管理员主动邀请客户来访。
#### 访客预约
##### 新增预约
- 用户在小程序选择预约的项目。输入手机号码，姓名，被访人手机号码，开始时间，结束时间。随从人数，车辆，上传人脸。点击预约。
- 平台收到预约信息后，判断当前项目是否在预约时间段，不在则返回预约失败。
- 在预约时间段内，则预约成功。
##### 预约审核
- 被访人，或者管理员收到预约访问请求，可以审核成功，审核失败。
- 用户会收到审核结果提醒，审核成功的则可以访问。
##### 访客来访开闸
- 用户在预约时间段内，可以访问。
- 访问通行的鉴权方式可以是人脸，也可以是预约记录的二维码。
#### 邀请访客
##### 新增邀请
- 业主，管理员在小程序选择邀请项目。输入手机号码，姓名，开始时间，结束时间。随从人数，车辆，点击邀请。
- 平台收到邀请信息后，判断当前项目是否在预约时间段，不在则返回邀请失败。
##### 接收邀请
- 被邀请人，收到邀请访问请求，可以接收，可以拒绝。
##### 访客来访开闸
- 用户在邀请时间段内，可以访问。
- 访问通行的鉴权方式是预约记录的二维码。
### v2计划
#### 概述
V2也只实现访客预约跟邀请访客两种模式。做出以下优化：
- 优化一：对于访客预约的时候，输入项目去查询项目是一个比较不友好的操作。用户不输入的时候，是没有可选的。可以提供通过被访人手机号码，通过被访人手机号码，自动定位到项目，供用户选择。这里存在的问题就是用户隐私。
也可以通过项目设置一个简单的项目预约编号，用户输入编号查询，或者直接输入项目预约编号预约。
- 优化二：用户预约之后，应该可以设置一个催办审核的按钮。用户在长时间没有得到审核，可以点击催办审核。
- 优化三：对于有些项目只想提供预约，或者只想提供邀请，可以设置项目预约模式。

#### 详细设计
##### 项目预约管理
- 管理员可以通过页面设置项目预约信息。预约相关设置包含：
  - 预约时间周期 自然天  自然周
  - 预约时间段 开始时间  结束时间
  - 预约车场编号   前两万大写字母后四位数字 非必须
  - 邀请是否自动接收 默认 否
  - 预约模式   0 支持预约跟邀请  1 支持预约 2 支持邀请
- 平台将项目预约配置下发给E8。
##### 访客预约
- 访客通过跟项目方的协商得到项目方的名称或者预约项目编号。
- 用户在小程序选择预约的项目。需要输入的参数有：
  - 手机号码
  - 姓名
  - 被访人手机号码
  - 开始时间
  - 结束时间
  - 随行人数
  - 随行车牌
  - 人脸
- 判断项目是否存在。不存在则返回预约失败，错误信息：项目不存在。
- 判断被访人电话是否为业主，如果是不是业主则返回预约失败，错误信息：被访人不存在。
- 平台收到预约信息后，判断当前项目是否在预约时间段，不在则返回预约失败。错误信息：预约时间不在预约周期内。
- 判断预约时间段在不在项目的通行时间段内。不在则返回预约失败，错误信息：预约时间不在项目通行时间段内。 ps:通行时间段内，通道才可以打开。可以考虑通行时间段当成预约时间段，也可以校验通行时间段来限制预约时间段的设置。
- 预约提交成功，并同步给E8
- 同步给E8的时候还需要下发预约人脸凭证，二维码凭证
- 平台将生成审核消息给被访人。被访人打开小程序也可以看到审核消息。

###### 预约审核
- 被访人收到预约请求，可以审核成功，审核失败。
- 当被访人存在多个预约请求，支持批量审核通过。
###### 用户来访开闸
- 用户在预约时间段内，可以访问。
- 用户可以通过之前上传的人脸，通过用户人脸识别入场。
- 用户也可以通过预约的二维码入场。
- E8设备通过凭证判断用户是否可以入参。
- 如果用户有随行车辆，则E8识别车牌凭证入场。
- 开闸后，E8将开闸的消息同步给平台。
- 平台将预约记录更新已完成。

##### 邀请访客
###### 业主邀请
- 业主在小程序邀请人员。输入参数有：
  - 手机号码
  - 姓名
  - 开始时间
  - 结束时间
  - 随从人数
  - 车牌
- 判断当前项目是否在预约时间段，不在则返回邀请失败。错误信息：邀请时间不在预约周期内。
- 判断预约时间段在不在项目的通行时间段内。不在则返回邀请失败，错误信息：预约时间不在项目通行时间段内。
- 平台收到邀请记录，如果项目设置邀请自动接收，则状态为已接收。否则状态为未接收。
- 平台将生成审核消息给被邀请人。被邀请人打开小程序也可以看到审核消息。
###### 客户接收邀请
- 被邀请人收到邀请请求，可以接收，可以拒绝。
- 接收邀请后，平台将下发凭证到E8,同步邀请记录到E8。
###### 用户来访开闸
- 同预约访客开闸部分，不重述。